#include<stdlib.h>
#include<stdio.h>
#include<stdbool.h>
#include<string.h>
#include <unistd.h> 
#include <string.h> 
#include <sys/types.h> 
#include <sys/socket.h> 
#include <arpa/inet.h> 
#include <netinet/in.h> 
#include <openssl/md5.h>
#include "utils.h"
#include <math.h>

#define MAXLOCATIONS 32
#define MAXIDVALUE 65536

int keyToId(char * key){
    unsigned char digest[16];
    MD5_CTX context;
    MD5_Init(&context);
    MD5_Update(&context, key, strlen(key));
    MD5_Final(digest, &context);
    int intHashValue;
    int first8bits = digest[0];
    first8bits = first8bits<<8;
    intHashValue = first8bits + digest[1];
    return intHashValue;
}

int nodeToId(struct sockaddr_in *socketAddr){
    char *ip;
    char port[6];
    int portNumber = socketAddr->sin_port;
    ip = inet_ntoa(socketAddr->sin_addr);
    int id = (keyToId(ip)+portNumber)%(MAXIDVALUE);
    return id;
}

typedef struct Node
{
    int nodeId;
    struct sockaddr_in socketAddr;
}Node;


typedef struct Chord
{
    Node node;
    Node successor;
    Node predecessor;
    Node *fingerTable;
}Chord;

Chord chord;

void sendUDP(char * msg, char ip[], int port, bool recvResponse, char * buffer)
{
    int sockfd;
    struct sockaddr_in     servaddr; 
  
    // Creating socket file descriptor 
    if ( (sockfd = socket(AF_INET, SOCK_DGRAM, 0)) < 0 ) { 
        perror("socket creation failed"); 
        exit(EXIT_FAILURE); 
    } 
  
    memset(&servaddr, 0, sizeof(servaddr)); 
      
    // Filling server information 
    servaddr.sin_family = AF_INET; 
    servaddr.sin_port = htons(port); 
    servaddr.sin_addr.s_addr = inet_addr(ip); 
      
    int n, len; 
      
    sendto(sockfd, (const char *)msg, strlen(msg), 
        MSG_CONFIRM, (const struct sockaddr *) &servaddr,  
            sizeof(servaddr)); 
    
    if (recvResponse)
    {
        n = recvfrom(sockfd, (char *)buffer, 1000,  
                MSG_WAITALL, (struct sockaddr *) &servaddr, 
                &len); 
        buffer[n] = '\0'; 
    }
    
    close(sockfd);
}



void initChordStructure(struct sockaddr_in *joinNode){
    chord.fingerTable = (Node *) malloc(log(MAXLOCATIONS)*sizeof(Node));
    char ip[16] = "190.11.111.11";//getip();
    int port = 199;
    getSocketFromIpAndPort(ip,port,&chord.node.socketAddr);
    printf("%s",inet_ntoa(chord.node.socketAddr.sin_addr));
    // strcpy(chord.selfIp ,ip);
    // chord.selfId = nodeToId(ip,port);
    // chord.predecessor =-1;
    // if (joinIp==NULL)
    // {
    //     chord.successor = chord.selfId;
    // }
    // else
    // {
    //     /* send find successor packet to the ip */
    //     // Listen for reply 
    //     // update successor
    // }
    
}

int main() {
    initChordStructure(NULL);
}

// void closestPreceedingNode(int id, char ip[]){
//     int m= log(MAXLOCATIONS);
//     Finger* f=chord.finger;
//     for (int i = m-1; i >=0; i--)
//     {        
//         int nextId = f[m].nextId;
//         if (nextId>chord.selfId && nextId<=id)
//         {
//             strcpy(ip,f[m].ip);
//             return;
//         }
        
//     }
//     strcpy(ip,f[0].ip); //????
// }

// Node findSuccessor(int id, char ip[], int port, bool block){
//     Node n;
//     n.nodeId=-1;
//     if (id>=chord.selfId && id<=chord.successor)
//     {
//         n.nodeId=chord.selfId;
//         strcpy(n.ip,chord.selfIp);
//         if (block)
//         {
            
//         }
//         else
//         {
//             return n;                    
//         }
        
//     }
//     else
//     {
//         char preceedingIp[16];
//         closestPreceedingNode(id,preceedingIp);
//         char msg[1000],buffer[1000];
//         //make_packet and send
//         sendUDP(msg,ip,port,true,buffer);
//         return n;
//     }
        
// }

// void sendPredecessor(char ip[], int port){
//     int sockfd; 
//     char msg[1000];
//     ToXML(msg,ip,port);//TO be changed
//     sendUDP(msg,ip,port,false,NULL);
// }

// void stabilize(){
//     char msg[1000],buffer[1000];
//     sendUDP(msg,chord.successorIp,chord.successorPort,true,buffer);
// }
